﻿#ifndef RADARSERVER_H
#define RADARSERVER_H

#include <QObject>
#include <QThread>
#include <QWebSocket>
#include <QWebSocketServer>
#include <QString>
#include <QDebug>

class RadarServer : public QObject
{
    Q_OBJECT
public:

    quint16 port;

    QWebSocketServer *m_pWebSocketServer;
    QList<QWebSocket *> m_clients;

    explicit RadarServer(QObject *parent = nullptr, quint16 port = 1235);
    virtual ~RadarServer();

signals:
    void SigRadarGen(int order);
public slots:
    void onNewConnection();
    void processMessage(QString message);
    void socketDisconnected();
};

#endif // RADARSERVER_H
